/*
	Copyright 2010-2014 David "Alemarius Nexus" Lerch

	This file is part of libgta.

	libgta is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	libgta is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with libgta.  If not, see <http://www.gnu.org/licenses/>.

	Additional permissions are granted, which are listed in the file
	GPLADDITIONS.
 */

#ifndef RIGIDBODYSCENEOBJECT_H_
#define RIGIDBODYSCENEOBJECT_H_

#include <btBulletDynamicsCommon.h>
#include "SceneObject.h"
#include "../../resource/collision/CollisionShapePointer.h"



class RigidBodySceneObject : public virtual SceneObject, public btMotionState
{
public:
	virtual void getWorldTransform(btTransform& trans) const;
	virtual void setWorldTransform(const btTransform& trans);
	virtual CollisionShapePointer* getCollisionShapePointer() = 0;
	virtual float getMass() const = 0;
	virtual void setMass(float m) = 0;
	virtual void getCollisionBoundingSphere(Vector3& center, float& radius) = 0;
	virtual void getCollisionBoundingBox(Vector3& min, Vector3& extX, Vector3& extY, Vector3& extZ) = 0;
};

#endif /* RIGIDBODYSCENEOBJECT_H_ */
