/*
	Copyright 2010-2014 David "Alemarius Nexus" Lerch

	This file is part of gtaformats.

	gtaformats is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	gtaformats is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with gtaformats.  If not, see <http://www.gnu.org/licenses/>.

	Additional permissions are granted, which are listed in the file
	GPLADDITIONS.
 */

#ifndef DFFLOADER_H_
#define DFFLOADER_H_

#include "DFFMesh.h"
#include "../rwbs/RWSection.h"
#include <nxcommon/file/File.h>



class DFFLoader {
public:
	DFFMesh* loadMesh(RWSection* clump);
	DFFMesh* loadMesh(istream* stream);
	DFFMesh* loadMesh(const File& file);

	bool hasIntegratedCOLModel(istream* stream, bool& hasModel);

private:
	bool gotoClumpSection(istream* stream, RWSectionHeader* outHeader);
	RWSection* loadClumpSection(istream* stream);
};

#endif /* DFFLOADER_H_ */
