/*
	Copyright 2010-2014 David "Alemarius Nexus" Lerch

	This file is part of gtaformats.

	gtaformats is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	gtaformats is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with gtaformats.  If not, see <http://www.gnu.org/licenses/>.

	Additional permissions are granted, which are listed in the file
	GPLADDITIONS.
 */

#ifndef HANDLINGREADER_H_
#define HANDLINGREADER_H_

#include <istream>
#include <nxcommon/file/File.h>
#include "HandlingEntry.h"

using std::istream;



class HandlingReader
{
public:
	HandlingReader(istream* stream, bool deleteStream);
	HandlingReader(const File& file);
	~HandlingReader();

	HandlingEntry* readEntry();

private:
	void init(istream* stream, bool deleteStream);

private:
	istream* stream;
	bool deleteStream;
};

#endif /* HANDLINGREADER_H_ */
