/*
	Copyright 2010-2013 David "Alemarius Nexus" Lerch

	This file is part of nxcommon.

	nxcommon is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	nxcommon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with nxcommon.  If not, see <http://www.gnu.org/licenses/>.

	Additional permissions are granted, which are listed in the file
	GPLADDITIONS.
 */

#ifndef NXCOMMON_CONFIG_H_
#define NXCOMMON_CONFIG_H_

// This file is the very first file included by virtually all files that use libnxcommon, so it is also used as a
// general-purpose file for global definitions.


#ifdef _MSC_VER
#	pragma warning(disable : 4996)
#endif

#if defined(__unix) || defined(__unix__) || defined(__APPLE__)
#include <unistd.h>
#endif

#include <nxcommon/nxcommon_stdint.h>
#include <nxcommon/types.h>

#ifdef _MSC_VER

// For char16_t/char32_t
#include <yvals.h>

// windef.h defines min() and max() as macros. These interfere with std::min and std::max, but we can use this macro to
// disable them.
#define NOMINMAX

// To define things like M_PI
#define _USE_MATH_DEFINES

#endif

#ifdef _MSC_VER
#define UTF16_LIT(str) ((const char16_t*) L ## str)
#define UTF16_LITC(str) L ## str
#else
#define UTF16_LIT(str) u ## str
#define UTF16_LITC(str) u ## str
#endif


#define PI 3.141593f


#if defined(__GNUC__)  &&  defined(__GXX_EXPERIMENTAL_CXX0X__)
#define CXX0X_AVAILABLE
#endif

#define NXCOMMON_EXCEPTION_POSITION_INFO
#define NXCOMMON_SQLITE_ENABLED
/* #undef NXCOMMON_MYSQL_ENABLED */
/* #undef NXCOMMON_PSQL_ENABLED */
#define NXCOMMON_LUA_ENABLED
#define NXCOMMON_QT_SUPPORT
#define NXCOMMON_QT_SUPPORT_VERSION 5
#define NXCOMMON_BULLET_SUPPORT

#ifdef NXCOMMON_QT_SUPPORT
#define NXCOMMON_QT_SUPPORT_ENABLED
#endif

#ifdef NXCOMMON_BULLET_SUPPORT
#define NXCOMMON_BULLET_SUPPORT_ENABLED
#endif

/* #undef _CMAKE_NXCOMMON_HAVE_SVNREV */

// Special check on Mac OS X to allow building of universal binaries.
#ifdef __APPLE__
#ifdef __powerpc
#define NXCOMMON_BIG_ENDIAN
#endif
#else
/* #undef NXCOMMON_BIG_ENDIAN */
#endif

#ifndef NXCOMMON_BIG_ENDIAN
#define NXCOMMON_LITTLE_ENDIAN
#endif

#define NXCOMMON_VERSION_MAJOR 0
#define NXCOMMON_VERSION_MINOR 1
#define NXCOMMON_VERSION_SUFFIX "-dev"

#ifdef _CMAKE_NXCOMMON_HAVE_SVNREV
#define NXCOMMON_VERSION_SVNREV 
#endif

#define NXCOMMON_VERSION "0.1-dev"

#endif /* NXCOMMON_CONFIG_H_ */
